
version: '3.7'

# Settings and configurations that are common for all containers
x-minio-common: &minio-common
  image: quay.io/minio/minio:RELEASE.2023-01-20T02-05-44Z
  command: server --console-address ":9001" http://minio{0...{{ number_of_nodes - 1 }}}/data{1...2}
  expose:
    - "9000"
    - "9001"
  environment:
    MINIO_ROOT_USER_FILE: /run/secrets/minio_access_key
    MINIO_ROOT_PASSWORD_FILE: /run/secrets/minio_secret_key
  secrets:
    - minio_access_key
    - minio_secret_key
  healthcheck:
    test: ["CMD", "curl", "-f", "http://localhost:9000/minio/health/live"]
    interval: 30s
    timeout: 20s
    retries: 3

# starts 4 docker containers running minio server instances.
# using nginx reverse proxy, load balancing, you can access
# it through port 9000.

services:
{% for node in  range(number_of_nodes)%}

  minio{{ node }}:
    <<: *minio-common
    hostname: minio{{ node }}
    volumes:
      - data{{ node }}-1:/data1
      - data{{ node }}-2:/data2

{% endfor %}

  nginx:
    image: nginx:1.19.2-alpine
    hostname: nginx
    volumes:
      - ./nginx.conf:/etc/nginx/nginx.conf:ro
    ports:
      - "9000:9000"
      - "9001:9001"
    
    depends_on:
{% for node in  range(number_of_nodes)%}

      - minio{{ node }}

{% endfor %}

  viz:
    image: dockersamples/visualizer
    ports:
      - 8080:8080
    volumes:
        - /var/run/docker.sock:/var/run/docker.sock
    deploy:
        placement: 
            constraints: [node.role == manager]

## By default this config uses default local driver,
## For custom volumes replace with volume driver configuration.


volumes:
{% for node in  range(number_of_nodes)%}

  data{{ node }}-1:
  data{{ node }}-2:

{% endfor %}

secrets:
  minio_access_key:
    file: ./minio_access_key
  minio_secret_key:
    file: ./minio_secret_key